; returns blackbody spectrum in photons/lambda. wavelength in m, temperature in Kelvin
function blackbody, lam, temp

;lam = (0.45 + 0.05*findgen(10))*1e-6 ; 450-750nm
;hplanck = 6.626D-34
;clight = 2.997925D8  ; m/s
;kboltz = 1.380649D-23   ; J/K
;const = hplanck*clight/kboltz

const = 0.014387618  ; m.K  = c*h/k

; planck = (lam[0]/lam)^4 / (exp(const/lam/temp) -1)  ; in photons
planck = (lam[0]/lam)^5 / (exp(const/lam/temp) -1)  ; in ergs


return, planck/max(planck)

;plot, lam*1e6, planck
end
;----------------------------------------------------

