; Ring centering by correlation. See corcent.py
pro corcent, file

; fixed parameters
rad = 12. ; template ring radius
dr = 3. ; template ring half-width
threshold = 10  ; CCF peak height

 img1 = float(readfits(file))
 nx = (size(img1))[1] 


r = shift(dist(nx,nx), nx/2, nx/2)

tmpl = fltarr(nx,nx)
tmpl[where((r gt rad-dr) and (r lt rad+dr))] = 1.


 ccf = float(shift(fft( fft(img1)*conj(fft(tmpl)), /inverse),nx/2,nx/2))

 cmax = max(ccf)
 peak = cmax/mean(ccf)
 print, 'CCF peak: ', peak

 if (peak gt threshold) then begin 

   i = (where(ccf eq cmax))[0]
   xc = i mod nx
   yc = i / nx
   print, 'xc, yc, peak: ', xc, yc, peak
   plot, ccf[*,yc]

  endif else begin 
     print, 'No star!'
   endelse

 stop

;  writefits, 'corel.fits', ccf

end
