; Profile restoration from indices, NNLS method. Aug 21, 2020
; uses nnls.pro
;-----------------------------------------------------
; z is the altitude grid [m], wt[nind,nlay] is the weight matrix
pro getprof, z, wt, scint, escint, prof, chi2


nlay = n_elements(z)  ; layers and noise
nind = n_elements(scint)

; Create internal NNLS variables
b = scint ; input indices
sigma = escint ; rms error
a = transpose(wt) ; [nind, nlay]

; weight the equations by 1/sigma
weight = 1./sigma
;weight = 1.

b = b*weight
for i=0,nlay-1 do a[i,*] = a[i,*]*weight

nmax = max([nlay,nind])
x = fltarr(nmax)
w = fltarr(nmax)
idx = intarr(nmax)

;stop
nnls, a, nind, nlay, b, x, rnorm, w, idx, mode

chi2 = rnorm
prof = x[0:nlay-1]
;stop

end
;-----------------------------------------------------------
;-----------------------------------------------------------
;-----------------------------------------------------------

