; GUI intercace to turbulence profile data
; 2020-08-11
pro xd_event, ev 

  common xdcomm, xdbase, dat, index, eldat, whichpar, savefile, xdpar  


type = tag_names(ev, /structure) ; name of the {ev} structure
  case type of
;--------------------
'WIDGET_BUTTON': begin
 widget_control,ev.id, get_value=value 
 case value of
   'Exit': widget_control, ev.top, /destroy
   '>':   xdnext, 1
   '<':   xdnext, -1
   'APS': begin
       print, 'Plotting angular power spectrum'
       ; stop
       arg = findgen(xdpar.inpar.mmax +1)
       plot, arg, eldat.pow, xtitle='m', ytitle='Power', /ylog
       oplot, arg, eldat.cov, li=2
       oplot, [1,xdpar.inpar.mmax+1], eldat.anoise*[1,1], li=1
   ;    oplot, arg, eldat.anoise*exp(-0.15*(arg/eldat.rad)^2), li=1
   ;    oplot, [25,30], eldat.anoise*[1,1], li=2 	   
    end ; aps
  'Profrest': begin
     testprof, xdpar.inpar, index, eldat.bv, eldat.zen
   end
  'Av.img': begin
    img = readfits(xdpar.dir+eldat.fname+'-av.fits')
    tvscl, congrid(img,256,256)
  end
  'Cubecoef': begin
      cube = readfits(xdpar.dir+eldat.fname+'.fits')
;      flat = readfits(xdpar.dir+'flat.fits')
      cubecoef, cube, xdpar.inpar, coef, impar,  /displ
;      cubecoef, cube, xdpar.inpar, coef, impar, flat=flat, /displ

     save, file=xdpar.dir+eldat.fname+'.idl', coef, impar  ; save coefficients
   
   end
  
 'Save': begin 
     print, 'Saving DAT structure in '+savefile
     save, fi=savefile, dat
    end ; save    
 'Edit':  begin
    print, 'Edit button'
       n = 9
       whichpar = lonarr(n)
       bas0 = widget_base(title='Parameter editor',/row,uvalue='Catedit')
       bas01 = widget_base(bas0,/column,uvalue='Catedit')
       bas02 = widget_base(bas0,/column,uvalue='Catedit')
       bas03 = widget_base(bas0,/column,uvalue='Catpedit')
       parname = (tag_names(eldat))[0:n-1]


   for i=0,n-1 do begin  ; comp parameters
   case datatype(eldat.(i)) of
'INT':   field = cw_field(bas01,title=parname[i], value = eldat.(i), /all_events, /int,uvalue='Compedit') 
'LON':   field = cw_field(bas01,title=parname[i], value = eldat.(i), /all_events, /lon,uvalue='Compedit') 
'FLO':   field = cw_field(bas01,title=parname[i], value = eldat.(i), /all_events, /flo,uvalue='Compedit') 
'STR':   field = cw_field(bas01,title=parname[i], value = eldat.(i), /all_events, /str,uvalue='Compedit') 
  else: field=-1
  endcase  
   whichpar[i] = field
 endfor

 ;stop
       but_s = widget_button(bas03, value='OK',xsize=60,uvalue='Compedit')
       but_d = widget_button(bas03, value='Quit',xsize=60,uvalue='Compedit')
       widget_control, bas0, /realize, group_leader=bas0
       xmanager, 'xcatedit', bas0, group_leader=bas0
       
 end ; edit


  else:
 endcase ; button case
 end ; button widget
;---------------------------
;--------------------------- Edit events
else: begin 
 widget_control,ev.id, get_uvalue=uvalue 
 if (uvalue eq 'Paredit') then begin
  widget_control,ev.id, get_value=value
 case ev.id of
  widget_info(xdbase,find_by_uname='wds_label'): begin
    sel = (where(cat.wds ge trim(value)))[0] 
;    stop
    if (sel ge 0) then begin
      index = sel
      xcatnext, 0 
   endif else begin 
    print, value, ' not found'
  endelse 
  end ; wds

  widget_info(xdbase,find_by_uname='name_label'): begin
     print, 'Name: ', value      
  end ; name
  else:
  endcase ; edit events
  endif ; paredit
end  ; edit events
endcase ; event-type case
end
;--------------------------------------------------------------------
; edit component parameters
pro xcatedit_event, ev

 common xdcomm

  widget_control,ev.id, get_uvalue=uvalue 
;  print, 'xdedit_event'
;  stop
  if (uvalue ne 'Compedit') then return

 type = tag_names(ev, /structure)
 case type of
'WIDGET_BUTTON': begin
    widget_control,ev.id, get_value=value  
    case value of
   'Quit': widget_control, ev.top, /destroy
   'OK': begin 
       dat[index] = eldat
      widget_control, ev.top, /destroy 
      showdat
   end 
   else:
   endcase
   end  
;---------------------------
else: begin
    sel = where(ev.id eq whichpar)
   ;stop
     if (sel ne -1) then begin
      widget_control,ev.id, get_value=value  
      n = 9
      value = value[0]  
      if (sel lt n) then  eldat.(sel) = value 
;      print, 'New value, whichpar ', value, sel
    endif 
   end
endcase

end

;---------------------------------------------------------------------
;--------------------------------------------------------------------
pro xd, par

common xdcomm

   if n_elements(par) eq 0 then begin
      print, 'Usage: xd, par!'
      return
   endif   

   savefile = par.datfile 
   xdpar={dir:par.dirdat,inpar:par}
   restore, savefile ; dat

  xdbase =  widget_base(title='RINGSS data GUI',/row)
  widget_control, xdbase, /realize


  col = widget_base(xdbase, /column)
  row1 =  widget_base(col, /row)
  junk = cw_field(row1,uname='fname_label',title='',uvalue='Paredit',xsize=30,/return_events,value=' ')


 junk =  widget_label(row1,xsize=90,uname='gain_label', value='x')
 junk =  widget_label(row1,xsize=90,uname='nz_label', value='x')
 junk =  widget_label(row1,xsize=90,uname='rad_label', value='x')
 junk =  widget_label(row1,xsize=80,uname='HR_label', value='x')

  row2 =  widget_base(col, /row)
  junk =  widget_label(row2,xsize=90,uname='flux_label', value='y')
  junk =  widget_label(row2,xsize=90,uname='scint_label', value='y')
  junk =  widget_label(row2,xsize=90,uname='see2_label', value='y')
  junk =  widget_label(row2,xsize=90,uname='see_label', value='y')
  junk =  widget_label(row2,xsize=90,uname='fsee_label', value='y')
  junk =  widget_label(row2,xsize=90,uname='wind_label', value='y')

  row2a =  widget_base(col, /row)
  junk =  widget_label(row2a,xsize=500,uname='prof_label', value=' ')

  row3 =  widget_base(col, /row)
 junk = widget_button(row3, xsize=60, value='APS',sensitive=1)
 junk = widget_button(row3, xsize=60, value='Profrest',sensitive=1)
 junk = widget_button(row3, xsize=60, value='Av.img',sensitive=1)
 junk = widget_button(row3, xsize=60, value='Cubecoef',sensitive=1)
  
  row4 =  widget_base(col, /row)
 junk = widget_button(row4, xsize=60, value='<',sensitive=1)
 junk = widget_button(row4, xsize=60, value='>',sensitive=1)
 junk = widget_button(row4, xsize=60, value='Edit',sensitive=1)
 junk = widget_button(row4, xsize=60, value='Save',sensitive=1)
 junk = widget_button(row4, xsize=60, value='Exit',sensitive=1)

  index = 0
  xdnext, 0 ; display current datum
  xmanager, 'xd', xdbase, /no_block
 

end
;--------------------------------------------------------------------
;--------------------------------------------------------------------
pro xdnext, step

common xdcomm

  index = (index + step) > 0
  if (index ge n_elements(dat)) then  index = n_elements(dat)-1
  eldat = dat[index]
  print, 'Sample: ',index
  showdat
  plot, eldat.pow, xtitle='m', ytitle='Power', /ylog
  oplot, [25,30], eldat.anoise*[1,1], li=2 
end
;--------------------------------------------------------------------
pro showdat

common xdcomm

  widget_control, widget_info(xdbase,find_by_uname='fname_label'), set_value=eldat.fname
  widget_control, widget_info(xdbase,find_by_uname='gain_label'),  set_value='G:'+string(eldat.gain,'(F5.0)')
  widget_control, widget_info(xdbase,find_by_uname='nz_label'),  set_value='Nz:'+string(eldat.nz,'(I4)')
  widget_control, widget_info(xdbase,find_by_uname='rad_label'),  set_value='Rad:'+string(eldat.rad,'(F6.2)')
  widget_control, widget_info(xdbase,find_by_uname='HR_label'),  set_value='HR: '+string(eldat.hr,'(I4)')

  widget_control, widget_info(xdbase,find_by_uname='flux_label'), set_value='F:'+string(eldat.flux,'(E10.2)')
  widget_control, widget_info(xdbase,find_by_uname='scint_label'), set_value='Scint:'+string(eldat.scint,'(F7.3)')
  widget_control, widget_info(xdbase,find_by_uname='see2_label'), set_value='See2:'+string(eldat.see2,'(F6.2)')
  widget_control, widget_info(xdbase,find_by_uname='see_label'), set_value='See:'+string(eldat.see,'(F6.2)')
  widget_control, widget_info(xdbase,find_by_uname='fsee_label'), set_value='Fsee:'+string(eldat.fsee,'(F6.2)')
  widget_control, widget_info(xdbase,find_by_uname='wind_label'), set_value='Wind:'+string(eldat.wind,'(F6.1)')

  s=''
  for i=0,7 do s +=string(eldat.prof[i]*1e13,'(F5.2)')+ '> '
  s += 'rmserr:'+string(eldat.rmserr,'(F5.3)')
  widget_control, widget_info(xdbase,find_by_uname='prof_label'), set_value=s

   
end
;--------------------------------------------------------------------
; read the data cube
pro getcube, cube
 common xdcomm
 cube = readfits(xdpar.dir+eldat.fname+'.fits')
end
;--------------------------------------------------------------------
; correlation coefficients
pro corel

common xdcomm

restore, xdpar.dir+eldat.fname+'.idl'  ; coef, impar

statmom,  coef, xdpar.inpar, pow, rrms, rnoise, cov=cov

m = xdpar.inpar.mmax
arg = findgen(m)+1
pow1 = (pow - eldat.anoise) > 0.1*eldat.anoise
rho = (cov/pow1)[1:m]
plot, arg, rho,xtitle='m', ytitle='Correlation'

;stop
end
;--------------------------------------------------------------------
; Temporal power spectrum
pro tempspec, m

common xdcomm

chunk = 200
restore, xdpar.dir+eldat.fname+'.idl'  ; coef, impar

idx1 = 2*xdpar.inpar.nsect + m  ; cosine
idx2 = 2*xdpar.inpar.nsect + xdpar.inpar.mmax+1 + m

pow = powerspec(coef[idx1,*],chunk) +  powerspec(coef[idx2,*],chunk)
pow[0] = pow[1]
freq = findgen(chunk/2)/(chunk*1.e-3)
plot, freq, pow, /ylog, xtitle='Frequency [Hz]', ytitle='Power'


hfnoise = mean(pow[chunk/2-20:chunk/2-1])

print, 'Variance: ', eldat.pow[m], 2.*total(pow)
print, 'Noise var, S/N: ', eldat.anoise, eldat.pow[m]/eldat.anoise
print, 'HF noise: ', hfnoise, hfnoise*chunk/eldat.anoise

; stop
end
;--------------------------------------------------------------------
; seeing plot vs. sample number or UT
pro seeing, ut=ut

common xdcomm

green='00AA00'x
magenta='AA00AA'x

r = dat.see2/dat.see
print, 'Median sect/scint seeing ratio: ', median(r)

n = n_elements(dat)
if keyword_set(ut) then begin 
  arg = (dat.jd -dat[0].jd + (dat[0].jd mod 1) -0.5)*24
  xt='UT [h]'
endif else begin 
  arg = findgen(n)
  xt='Sample'
endelse

plot, arg, dat.see, li=0, xs=1, ytitle='Seeing [arcsec]', xtitle=xt
oplot, arg, dat.see2, li=2, color=magenta
oplot, arg, dat.fsee, li=1, color=green
legend, ['Seeing(scint)', 'Seeing(sect)', 'Free seeing'], li=[0,2,1], colors=[0,magenta,green], /top, /right

end
;--------------------------------------------------------------------
pro fluxvar  ; flux disparity in sectors

common xdcomm

restore, xdpar.dir + eldat.fname+'.idl'
flux = total(coef[8:15,*], 2)/eldat.nz
print, 'Sector flux max/min: ', max(flux)/min(flux)		 
end
;--------------------------------------------------------------------
pro conjugation  ; plot conjugation distance

common xdcomm

d = xdpar.inpar.d
eps = xdpar.inpar.eps

rgeom = dat.rad*xdpar.inpar.pixel/(0.88 + 8.5e-5*xdpar.inpar.pdist)/206265.
h = d*(1. + eps)/(4.*rgeom)
plot, h

print, 'Mean conj. height: ', mean(h)
;stop
end
;--------------------------------------------------------------------
;--------------------------------------------------------------------
;--------------------------------------------------------------------
  
